;No Signal
;by Shiru 05.02.09 for raww.orgy 2009

; SjAsmPlus
;   ZX Spectrum +2 ( )

    device zxspectrum128

OP_JP       equ #c3
OP_RET      equ #c9

CLS         equ #0d6b

    org #8000

begin
    call CLS
    dec de
    ex de,hl
    ld (hl),OP_RET
    ld sp,hl

fillAttrs
    ld hl,#5800
    ld e,20
.loop0
    ld c,6
    ld a,54
.loop1
    ld b,5
.loop2
    ld (hl),a
    inc hl
    djnz .loop2
    sub 9
    dec c
    jr nz,.loop1
    ld (hl),b
    inc hl
    ld (hl),b
    inc hl
    dec e
    jr nz,.loop0
 
.loop3
    ld (hl),7
    inc hl
    djnz .loop3
 
    display "fillAttrs ",/d,$-fillAttrs

printLine
    ld de,#50a3
    ld hl,messageStr
.loop0
    ld a,(hl)
    add a,a
    jp z,setSound
    push de
    push hl
    ld h,15
    ld l,a
    add hl,hl
    add hl,hl
    ld b,8
.loop1
    ld a,(hl)
    push hl
    ld c,8
.loop2
    rla
    push af
    adc hl,hl
    pop af
    adc hl,hl
    dec c
    jr nz,.loop2
    ex de,hl
    ld (hl),d
    inc l
    ld (hl),e
    inc h
    ld (hl),e
    dec l
    ld (hl),d
    inc h
    bit 3,h
    jr z,.loop3
    ld de,#f820
    add hl,de
.loop3
    ex de,hl
    pop hl
    inc l
    djnz .loop1

    pop hl
    inc hl

    pop de
    inc e
    inc e
    inc e
    jr .loop0

    display "printLine ",/d,$-printLine

messageStr
    .db "NO SIGNAL"
soundData
    .db 0,110,7,254,8,15,1,0

code0
    ei
    halt
    ld bc,#0afe     ;10t
    djnz $          ;13/8t=135t
 
code2
    ld a,l          ;4t
    dec l           ;4t
    out (c),a       ;12t
 
code3
    ld b,3          ;7t
    djnz $          ;13/8t=41t

code4
    ld a,7          ;7t
    out (#fe),a     ;11t
    ld l,a          ;4t
    dec l           ;4t
    add ix,ix       ;15t
    inc de          ;6t
code4a
    xor a           ;4t
    dec l           ;4t
    out (c),a       ;12t
 
    ld a,9          ;7t
    dec a           ;4t
    jr nz,$-1       ;12/7t
    add hl,bc       ;11t=157t

code5
    ld a,235        ;7t
    add ix,ix       ;15t
    dec a           ;4t
    jr nz,$-3       ;12/7t
    ld a,i          ;9t=7296t
 
code6

copyOnce
    ld b,1
copyData
.loop0
    push bc
    push hl
    ld b,0
    ldir
    pop hl
    pop bc
    djnz .loop0
    add hl,bc
    ret

genLCode
.loop0
    ;ld hl,code4
    ld l,code4&255
    ld c,code4a-code4
    call copyOnce
    ;ld hl,code2
    ld l,code2&255
    ld bc,(7*256)+code3-code2
    call copyData
    ;ld hl,code3
    ;ld c,code4-code3
    call copyOnce
    dec a
    jr nz,.loop0
    ret

setSound
    ;ld hl,soundData
.loop0
    ld bc,#fffd
    outi
    ld b,#bf
    ld a,(hl)
    inc hl
    out (c),a
    or a
    jr nz,.loop0
 
    display "setSound ",/d,$-setSound

genCode
    ld de,mainLoop
    ;ld hl,code0
    ld c,code2-code0
    call copyOnce

    ld a,62
    call genLCode

    ;ld hl,code4
    ld bc,(160*256)+code5-code4
    call copyData
    ;ld hl,code5
    ld c,code6-code5
    call copyOnce

    ld a,56
    ld i,a
    im 2
    call genLCode
 
    ex de,hl
    ld (hl),OP_JP
    inc hl
    ld (hl),mainLoop&255
    inc hl
    ld (hl),mainLoop/256
 
    display "genCode ",/d,$-genCode

mainLoop

end

    display /d,$-begin

    savesna "nosignal.sna",begin
    savebin "nosignal.c",begin,end-begin